//+------------------------------------------------------------------+
//|                                         TurnStrategyTemplate.mq4 |
//|                                                  Shestkov Vasily |
//|                          http://www.vkontakte.ru/id6694726?54985 |
//+------------------------------------------------------------------+
#property copyright "Shestkov Vasily"
#property link      "http://www.vkontakte.ru/id6694726?54985"

//-----    
#include <stderror.mqh>

//-------   ---------------------------------------+
#define MAGIC_NUMBER     20080610     //  
#define SOUND_FILE       "expert.wav" //       
#define BUY_COLOR        LightBlue    //    
#define SELL_COLOR       LightCoral   //    

//----    ----------------------------------------+
#define UP_TREND      1
#define FLAT          0
#define DOWN_TREND   -1

//-----    ---------------------------------+
#define OPEN_POSITION_ALLOW    0
#define MODIFY_POSITION_ALLOW  1
#define CLOSE_ALL              2

//-------    --------------------------------------+
string allOrdersComment  = "";
bool   gbDisabled        = False;   //   
int    minSlippage       = 3;       //   
int    maxSlippage       = 5;       //   
int    tryNumber         = 5;       //   
int    setOrderLastError = 0;       //    SetOrder

//-------      SetOrder -------+
int    lastError        = 0;       //    SetOrder

//-------   ---------------------------------------+
extern bool useDebugOrderSend     = true;
int errTest[] = {0, 128, 0, 142, 0, 143, 0, 4, 132}; //      

   // ---- 
extern int    x1 = 120;
extern int    x2 = 44;
extern int    x3 = 16;
extern int    x4 = 118;

static int prevtime = 0;
static int spread = 3;
extern double sl = 50;
extern double lots = 0.1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   allOrdersComment = "[1]";
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int perceptronValue = perceptron();
   Comment(perceptronValue);   
   // ,    
   //    ,     
   if(Time[0] == prevtime) {
      return(0);
   } else {
      prevtime = Time[0];
   }
   
   //----
   if(IsTradeAllowed()) {
      spread = MarketInfo(Symbol(), MODE_SPREAD);
   } else {
      prevtime = Time[1];
      return(0);
   }
   int ticket = -1;
   // check for opened position
   //    :
   int total = OrdersTotal();   
   for(int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC_NUMBER) {
         int prevticket = OrderTicket();
         if (OrderType() == OP_BUY) {
            if(Bid > (OrderStopLoss() + (sl * 2  + spread) * Point)) {               
               if (perceptronValue == DOWN_TREND) { 
                  ticket = SetOrderMain(Symbol(), OP_SELL, lots * 2, Bid, Ask + sl * Point, 0, MAGIC_NUMBER);
                  if(ticket < 0) {
                     prevtime = Time[1];
                  } else {
                     OrderCloseBy(ticket, prevticket, Blue);   
                  }
               } else { 
                  bool isModifyOk = OrderModify(OrderTicket(), OrderOpenPrice(), Bid - sl * Point, 0, 0, Blue);
                  if(!isModifyOk) {
                     prevtime = Time[1];
                  }
               }
            }  
         } else {
            if (Ask < (OrderStopLoss() - (sl * 2 + spread) * Point)) {
               if (perceptronValue == UP_TREND) { 
                  ticket = SetOrderMain(Symbol(), OP_BUY, lots * 2, Ask, Bid - sl * Point, 0, MAGIC_NUMBER);
                  if(ticket < 0) {
                     prevtime = Time[1];
                  } else {
                     OrderCloseBy(ticket, prevticket, Blue);   
                  }
               } else { 
                  isModifyOk = OrderModify(OrderTicket(), OrderOpenPrice(), Ask + sl * Point, 0, 0, Blue);
                  if(!isModifyOk) {
                     prevtime = Time[1];
                  }  
               }
            }  
         }
         
         return(0);
         }
     }
   
   //********************************************************************
   // check for long or short position possibility
   //    :
 
   switch (perceptronValue) {
      case UP_TREND:
         ticket = SetOrderMain(Symbol(), OP_BUY, lots, Ask, Bid - sl * Point, 0, MAGIC_NUMBER);
         if(ticket < 0) {
           prevtime = Time[1];
         }
         break;
      case DOWN_TREND:
         ticket = SetOrderMain(Symbol(), OP_SELL, lots, Bid, Ask + sl * Point, 0, MAGIC_NUMBER);
         if(ticket < 0) {
            prevtime = Time[1];
         }
         break;
      case FLAT:
         break;
   }
//--- exit
   return(0);
}
//+------------------------------------------------------------------+

int perceptron() {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;

   double a1 = iAC(Symbol(), 0, 0);
   double a2 = iAC(Symbol(), 0, 7);
   double a3 = iAC(Symbol(), 0, 14);
   double a4 = iAC(Symbol(), 0, 21);

   double res = w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4;

   if (res < 0) {
      return (UP_TREND);
   } else if (res > 0) {
      return (DOWN_TREND);
   } else {
      return(FLAT);
   }
   return (res);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int SetOrderMain(string symbol, int operation, double lots, double price, double stop_loss=0, double take_profit=0, int magic=0, datetime expirationTime=0, int maxWorkTime=0) {
   for (int currentTry = 0; currentTry < tryNumber; currentTry++) {
      int ticket = SetOrder(symbol, operation, lots, price, stop_loss, take_profit, magic, expirationTime);
      if (ticket > 0) {
         return (ticket);
      }
      correctSetOrderMainError(ticket, symbol, operation, lots, price, stop_loss, take_profit, magic, expirationTime);
   }
   return (ticket);
}

int correctSetOrderMainError(int err, string symbol, int operation, double& lots, double& price, double& stop_loss, double& take_profit, int magic, datetime& expirationTime) {
   switch(err) {
      case ERR_COMMON_ERROR: //     ,        
      case ERR_OLD_VERSION:
      case ERR_ACCOUNT_DISABLED:
      case ERR_INVALID_ACCOUNT:
      case ERR_TRADE_DISABLED:
         gbDisabled=True; 
         break;
      
      case ERR_ORDER_LOCKED:
      case ERR_LONG_POSITIONS_ONLY_ALLOWED:
      case ERR_TRADE_TOO_MANY_ORDERS:
         break;
      
      case ERR_TRADE_EXPIRATION_DENIED:
         expirationTime = 0;
         break;
      
      case ERR_INVALID_STOPS:
         correct130(symbol, operation, price, stop_loss, take_profit);
         break;
   }
}

//   
int correct130(string symbol, int operation, double& price, double& stop_loss, double& take_profit) {
   int msl = MarketInfo(symbol, MODE_STOPLEVEL);
   double mp=MarketInfo(symbol, MODE_POINT);
   double pa=MarketInfo(symbol, MODE_ASK);
   double pb=MarketInfo(symbol, MODE_BID);
   if (pa == 0 && pb == 0) {
      Print("SetOrder():       "+symbol);
   }
   /*Print("Ask=",pa,"  Bid=",pb,"  sy=",symbol,"  ll=",lots,"  op=",GetNameOP(operation),
         "  pp=",price,"  sl=",stop_loss,"  tp=",take_profit,"  mn=",magic);*/
   
   switch (operation) {
      case OP_BUYLIMIT:
         if (price > pa - msl * mp) price = pa - msl * mp;
         if (stop_loss > price - (msl + 1) * mp) stop_loss = price - (msl + 1) * mp;
         if (take_profit > 0 && take_profit < price + (msl + 1) * mp) take_profit = price + (msl + 1) * mp;
         break;
      case OP_BUYSTOP:
         if (price < pa + (msl + 1) * mp) price = pa + (msl + 1) * mp;
         if (stop_loss > price - (msl + 1) * mp) stop_loss = price - (msl + 1) * mp;
         if (take_profit > 0 && take_profit < price + (msl + 1) * mp) take_profit = price + (msl + 1) * mp;
         break;
      case OP_SELLLIMIT:
         if (price < pb + msl * mp) price = pb + msl * mp;
         if (stop_loss > 0 && stop_loss < price + (msl + 1) * mp) stop_loss = price + (msl + 1) * mp;
         if (take_profit > price - (msl + 1) * mp) take_profit = price - (msl + 1) * mp;
         break;
      case OP_SELLSTOP:
         if (price > pb - msl * mp) price = pb - msl * mp;
         if (stop_loss > 0 && stop_loss < price + (msl + 1) * mp) stop_loss = price + (msl + 1) * mp;
         if (take_profit > price - (msl + 1) * mp) take_profit = price - (msl + 1) * mp;
         break;
      case OP_BUY:
         break;
      case OP_SELL:
        break;
   }
   return (-1);
}

/**
 *  
 * symbol - 
 * operation - 
 * lots -  
 * price - 
 * stop_loss -   
 * take_profit -   
 * magic - 
 * expirationTime -   ,     
 */
int SetOrder(string symbol, int operation, double lots, double price, double stop_loss=0, double take_profit=0, int magic=0, datetime expirationTime=0, datetime endTime=0) {
   color    clOpen;
   datetime ot;

   if (symbol == "") { 
      symbol = Symbol();
   }
   
   //   
   if (operation == OP_BUYLIMIT || operation == OP_BUYSTOP || operation == OP_BUY) {
      clOpen = BUY_COLOR;
   } else {
      clOpen = SELL_COLOR;
   }
   
   //         
   if (expirationTime > 0 && expirationTime < TimeCurrent()) {
      expirationTime = 0;
   }
   
   for (int currentTry = 0; currentTry < tryNumber; currentTry++) {
      //       
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
         Print("SetOrder():   ");
         break;
      }
      //    
      while (!IsTradeAllowed()) {
         Sleep(5000);
      }

      //  
      RefreshRates(); 

      ot = TimeCurrent(); //  !!!!!!!!!!!!!!!!
      
      //    
      int ticket = OrderSendProxy(symbol, operation, lots, price, minSlippage, stop_loss, take_profit, allOrdersComment, magic, expirationTime, clOpen);

      if (ticket > 0) {
         return(ticket);
      } else {
         //     
         int err = GetLastErrorProxy();
         Print(ErrorDescription(err), ":, try ", currentTry);
         //      
         ticket = correctSetOrderError(err, symbol, operation, magic, ot);

         if (ticket == 0) {
            continue;
         } else {
            return (ticket);
         }
      }
   }
   return (0);
}

/**
 *      
 */
int correctSetOrderError(int errCode, string symbol, int operation, int magic, datetime ot) {
   int ticket = 0;
   switch (errCode) {
      case ERR_TRADE_TIMEOUT:
      case 142: //        
      case 143:
         //   
         Sleep(1000 * 66); 
         ticket = ExistOrders(symbol, operation, magic, ot);
         break;
      
      case ERR_SERVER_BUSY:
      case ERR_MARKET_CLOSED:
         Sleep(1000 * 300); //   (5 )
         break;
      
      case ERR_TOO_FREQUENT_REQUESTS:
      case ERR_TOO_MANY_REQUESTS:
         Sleep(1000 * 100); //   (100 )
         break;
      
      case ERR_TRADE_CONTEXT_BUSY:
         //    
         while (IsTradeContextBusy()){ Sleep(1000 * 11); }
         break;            
      
      case ERR_NO_CONNECTION:
         //     
         while (!IsConnected()){ Sleep(1000); }
         break;
      
      case ERR_OFF_QUOTES:
         Sleep(1000 * 5.5); //   (5.5 )
         break;
      
      default:
         return (-errCode);
         break;
   }
   return (ticket);
}

/**
 *        
 */
int OrderSendProxy(string symbol, int operation, double lots, double price, int slippage, double stop_loss, double take_profit, string comment, int magic, datetime expirationTime, color clOpen) {
   int ticket = -1;
   if (!useDebugOrderSend) {
      ticket = OrderSend(symbol, operation, lots, price, slippage, stop_loss, take_profit, comment, magic, expirationTime, clOpen);   
   } else {
      static int lastIndex = 0;
      if (lastIndex >= ArraySize(errTest)){
         lastIndex = 0;
      }
      lastError = errTest[lastIndex];
      if (lastError == 0) {
         ticket = OrderSend(symbol, operation, lots, price, slippage, stop_loss, take_profit, comment, magic, expirationTime, clOpen);   
      }
      lastIndex++;
   }
   return (ticket);
}

/**
 *       useDebugOrderSend
 */
int GetLastErrorProxy() {
   int err;
   if (useDebugOrderSend) {
      err = lastError;
      lastError = 0;
   } else {
      err = GetLastError();
   }
   return (err);
}

//+----------------------------------------------------------------------------+
//|      :  ..                                                   |
//+----------------------------------------------------------------------------+
//|     : 22.03.2008                                                     |
//|   :                                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    error_code -                                                   |
//+----------------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string = "";
   switch(error_code){
      //----    
      case 0:  error_string="ERR_NO_ERROR:    ."; break;

//-----    SetOrder

      //----  
      case 8:	error_string="ERR_TOO_FREQUENT_REQUESTS:   .    ,   ."; break; 
      case 141:	error_string="ERR_TOO_MANY_REQUESTS:   .    ,   ."; break; 

      //----   
      case 4:	error_string="ERR_SERVER_BUSY:   .         (  )."; break; 
      case 132:	error_string="ERR_MARKET_CLOSED:  .         (  )."; break; 
      case 131:	error_string="ERR_INVALID_TRADE_VOLUME:  ,    .          ."; break; 
      
      //----     
      case 128:	error_string="ERR_TRADE_TIMEOUT:     . ,     ( ,   1 ),  ,       (    ,        ,      )"; break; 
      case 142:	error_string="   .   ,           .        ,            .        128."; break; 
      case 143:	error_string="    .          .      ,    142.        128."; break; 

      //----    
      case 146:	error_string="ERR_TRADE_CONTEXT_BUSY:   .     ,   IsTradeContextBusy  FALSE."; break; 
      
      //----      
      case 6:	error_string="ERR_NO_CONNECTION:     .  ,     (,    IsConnected)      ( 5 )  ."; break; 
      
      //----    5 
      case 136:	error_string="ERR_OFF_QUOTES:  .   -  (,     ,  ,  )     .     5       RefreshRates   ."; break; 

//-----       SetOrderMain

      //----           
      case 2:	error_string="ERR_COMMON_ERROR:  .        .       ."; break; 
      case 5:	error_string="ERR_OLD_VERSION:    .      ."; break; 
      case 64:	error_string="ERR_ACCOUNT_DISABLED:  .      ."; break; 
      case 65:	error_string="ERR_INVALID_ACCOUNT:   .      ."; break; 
      case 133:	error_string="ERR_TRADE_DISABLED:  .      ."; break; 

      //----   
      case 130:	error_string="ERR_INVALID_STOPS:            (     ).       ,    -  .     5       RefreshRates   .    ,          ."; break; 

      //----      
      case 147:	error_string="ERR_TRADE_EXPIRATION_DENIED:      .       ,    expiration."; break; 

      //----    
      case 139:	error_string="ERR_ORDER_LOCKED:     .          ."; break; 
      case 140:	error_string="ERR_LONG_POSITIONS_ONLY_ALLOWED:   .   SELL ."; break; 
      case 148:	error_string="ERR_TRADE_TOO_MANY_ORDERS:       ,  .                ."; break; 

      case 1:	error_string="ERR_NO_RESULT: OrderModify        .         ."; break; 
      case 3:	error_string="ERR_INVALID_TRADE_PARAMETERS:      , ,  ,   ,    ,     ..    ."; break; 
      case 129:	error_string="ERR_INVALID_PRICE:   bid  ask, ,  .     5       RefreshRates   .    ,          ."; break; 
      case 134:	error_string="ERR_NOT_ENOUGH_MONEY:     .       .       5 ,  ,          ."; break; 
      case 135:	error_string="ERR_PRICE_CHANGED:  .         RefreshRates   ."; break; 
      case 138:	error_string="ERR_REQUOTE:   ,   bid  ask.         RefreshRates   .    ,          ."; break; 
      case 144:	error_string="       .          ."; break; 
      case 145:	error_string="ERR_TRADE_MODIFY_DENIED:  ,          -   .   ,   15 ,      RefreshRates   ."; break; 

      //---- mql4 errors
      case 4000: error_string=" "; break; 
      case 4001: error_string="  "; break; 
      case 4002: error_string="  -  "; break; 
      case 4003: error_string="    "; break; 
      case 4004: error_string="    "; break;
      case 4005: error_string="      "; break; 
      case 4006: error_string="    "; break; 
      case 4007: error_string="    "; break; 
      case 4008: error_string=" "; break; 
      case 4009: error_string="   "; break; 
      case 4010: error_string="    "; break; 
      case 4011: error_string="  "; break; 
      case 4012: error_string="    "; break; 
      case 4013: error_string="  "; break; 
      case 4014: error_string=" "; break; 
      case 4015: error_string=" "; break; 
      case 4016: error_string=" "; break; 
      case 4017: error_string=" DLL  "; break; 
      case 4018: error_string="  "; break; 
      case 4019: error_string="  "; break; 
      case 4020: error_string="     "; break; 
      case 4021: error_string="   ,   "; break; 
      case 4022: error_string=" "; break; 
      case 4050: error_string="   "; break; 
      case 4051: error_string="   "; break; 
      case 4052: error_string="   "; break; 
      case 4053: error_string=" "; break; 
      case 4054: error_string="  -"; break; 
      case 4055: error_string="  "; break; 
      case 4056: error_string=" "; break; 
      case 4057: error_string="   "; break; 
      case 4058: error_string="   "; break; 
      case 4059: error_string="     "; break; 
      case 4060: error_string="  "; break; 
      case 4061: error_string="  "; break; 
      case 4062: error_string="   string"; break; 
      case 4063: error_string="   integer"; break; 
      case 4064: error_string="   double"; break; 
      case 4065: error_string="    "; break; 
      case 4066: error_string="     "; break; 
      case 4067: error_string="    "; break; 
      case 4099: error_string=" "; break; 
      case 4100: error_string="    "; break; 
      case 4101: error_string="  "; break; 
      case 4102: error_string="   "; break; 
      case 4103: error_string="  "; break; 
      case 4104: error_string="    "; break; 
      case 4105: error_string="    "; break; 
      case 4106: error_string=" "; break; 
      case 4107: error_string="     "; break; 
      case 4108: error_string="  "; break; 
      case 4109: error_string="  .    \"  \"   ."; break; 
      case 4110: error_string="   .    ."; break; 
      case 4111: error_string="   .    ."; break; 
      case 4200: error_string="  "; break; 
      case 4201: error_string="   "; break; 
      case 4202: error_string="  "; break; 
      case 4203: error_string="  "; break; 
      case 4204: error_string="  "; break; 
      case 4205: error_string="  "; break; 
      case 4206: error_string="   "; break; 
      case 4207: error_string="    "; break; 
      default:   error_string=" ";
     }
   return(error_string);
  }

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
   if (TimeFrame == 0) TimeFrame=Period();
   switch (TimeFrame) {
      case PERIOD_M1:  return("M1");
      case PERIOD_M5:  return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1:  return("H1");
      case PERIOD_H4:  return("H4");
      case PERIOD_D1:  return("Daily");
      case PERIOD_W1:  return("Weekly");
      case PERIOD_MN1: return("Monthly");
      default:		   return("UnknownPeriod");
   }
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MAGIC_NUMBER                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
int ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(OrderTicket());
          }
        }
      }
    }
  }
  return(0);
}



